/*************************************************************
 * This file was automatically generated on 2012-02-15.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.TimeUnit;


public class BrickIMU extends Device {
	private final static byte TYPE_GET_ACCELERATION = (byte)1;
	private final static byte TYPE_GET_MAGNETIC_FIELD = (byte)2;
	private final static byte TYPE_GET_ANGULAR_VELOCITY = (byte)3;
	private final static byte TYPE_GET_ALL_DATA = (byte)4;
	private final static byte TYPE_GET_ORIENTATION = (byte)5;
	private final static byte TYPE_GET_QUATERNION = (byte)6;
	private final static byte TYPE_GET_IMU_TEMPERATURE = (byte)7;
	private final static byte TYPE_LEDS_ON = (byte)8;
	private final static byte TYPE_LEDS_OFF = (byte)9;
	private final static byte TYPE_ARE_LEDS_ON = (byte)10;
	private final static byte TYPE_SET_ACCELERATION_RANGE = (byte)11;
	private final static byte TYPE_GET_ACCELERATION_RANGE = (byte)12;
	private final static byte TYPE_SET_MAGNETOMETER_RANGE = (byte)13;
	private final static byte TYPE_GET_MAGNETOMETER_RANGE = (byte)14;
	private final static byte TYPE_SET_CONVERGENCE_SPEED = (byte)15;
	private final static byte TYPE_GET_CONVERGENCE_SPEED = (byte)16;
	private final static byte TYPE_SET_CALIBRATION = (byte)17;
	private final static byte TYPE_GET_CALIBRATION = (byte)18;
	private final static byte TYPE_SET_ACCELERATION_PERIOD = (byte)19;
	private final static byte TYPE_GET_ACCELERATION_PERIOD = (byte)20;
	private final static byte TYPE_SET_MAGNETIC_FIELD_PERIOD = (byte)21;
	private final static byte TYPE_GET_MAGNETIC_FIELD_PERIOD = (byte)22;
	private final static byte TYPE_SET_ANGULAR_VELOCITY_PERIOD = (byte)23;
	private final static byte TYPE_GET_ANGULAR_VELOCITY_PERIOD = (byte)24;
	private final static byte TYPE_SET_ALL_DATA_PERIOD = (byte)25;
	private final static byte TYPE_GET_ALL_DATA_PERIOD = (byte)26;
	private final static byte TYPE_SET_ORIENTATION_PERIOD = (byte)27;
	private final static byte TYPE_GET_ORIENTATION_PERIOD = (byte)28;
	private final static byte TYPE_SET_QUATERNION_PERIOD = (byte)29;
	private final static byte TYPE_GET_QUATERNION_PERIOD = (byte)30;
	private final static byte TYPE_ACCELERATION = (byte)31;
	private final static byte TYPE_MAGNETIC_FIELD = (byte)32;
	private final static byte TYPE_ANGULAR_VELOCITY = (byte)33;
	private final static byte TYPE_ALL_DATA = (byte)34;
	private final static byte TYPE_ORIENTATION = (byte)35;
	private final static byte TYPE_QUATERNION = (byte)36;

	public class Acceleration {
		public short x;
		public short y;
		public short z;

		public String toString() {
			 return "[" + "x = " + x + ", " + "y = " + y + ", " + "z = " + z + "]";
		}
	}

	public class MagneticField {
		public short x;
		public short y;
		public short z;

		public String toString() {
			 return "[" + "x = " + x + ", " + "y = " + y + ", " + "z = " + z + "]";
		}
	}

	public class AngularVelocity {
		public short x;
		public short y;
		public short z;

		public String toString() {
			 return "[" + "x = " + x + ", " + "y = " + y + ", " + "z = " + z + "]";
		}
	}

	public class AllData {
		public short accX;
		public short accY;
		public short accZ;
		public short magX;
		public short magY;
		public short magZ;
		public short angX;
		public short angY;
		public short angZ;
		public short temperature;

		public String toString() {
			 return "[" + "accX = " + accX + ", " + "accY = " + accY + ", " + "accZ = " + accZ + ", " + "magX = " + magX + ", " + "magY = " + magY + ", " + "magZ = " + magZ + ", " + "angX = " + angX + ", " + "angY = " + angY + ", " + "angZ = " + angZ + ", " + "temperature = " + temperature + "]";
		}
	}

	public class Orientation {
		public short roll;
		public short pitch;
		public short yaw;

		public String toString() {
			 return "[" + "roll = " + roll + ", " + "pitch = " + pitch + ", " + "yaw = " + yaw + "]";
		}
	}

	public class Quaternion {
		public float x;
		public float y;
		public float z;
		public float w;

		public String toString() {
			 return "[" + "x = " + x + ", " + "y = " + y + ", " + "z = " + z + ", " + "w = " + w + "]";
		}
	}

	public class Version {
		public String name = null;
		public short[] firmwareVersion = new short[3];
		public short[] bindingVersion = new short[3];

		public String toString() {
			 return "[" + "name = " + name + ", " + "firmwareVersion = " + firmwareVersion + ", " + "bindingVersion = " + bindingVersion + "]";
		}
	}

	public interface AccelerationListener {
		public void acceleration(short x, short y, short z);
	}

	public interface MagneticFieldListener {
		public void magneticField(short x, short y, short z);
	}

	public interface AngularVelocityListener {
		public void angularVelocity(short x, short y, short z);
	}

	public interface AllDataListener {
		public void allData(short accX, short accY, short accZ, short magX, short magY, short magZ, short angX, short angY, short angZ, short temperature);
	}

	public interface OrientationListener {
		public void orientation(short roll, short pitch, short yaw);
	}

	public interface QuaternionListener {
		public void quaternion(float x, float y, float z, float w);
	}

	public BrickIMU(String uid) {
		super(uid);

		bindingVersion[0] = 1;
		bindingVersion[1] = 0;
		bindingVersion[2] = 0;

		callbacks[TYPE_ACCELERATION] = new CallbackListener() {
			public void callback(byte[] data) {
				ByteBuffer bb = ByteBuffer.wrap(data, 4, data.length - 4);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short x = (bb.getShort());
				short y = (bb.getShort());
				short z = (bb.getShort());

				((AccelerationListener)listenerObjects[TYPE_ACCELERATION]).acceleration(x, y, z);
			}
		};

		callbacks[TYPE_MAGNETIC_FIELD] = new CallbackListener() {
			public void callback(byte[] data) {
				ByteBuffer bb = ByteBuffer.wrap(data, 4, data.length - 4);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short x = (bb.getShort());
				short y = (bb.getShort());
				short z = (bb.getShort());

				((MagneticFieldListener)listenerObjects[TYPE_MAGNETIC_FIELD]).magneticField(x, y, z);
			}
		};

		callbacks[TYPE_ANGULAR_VELOCITY] = new CallbackListener() {
			public void callback(byte[] data) {
				ByteBuffer bb = ByteBuffer.wrap(data, 4, data.length - 4);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short x = (bb.getShort());
				short y = (bb.getShort());
				short z = (bb.getShort());

				((AngularVelocityListener)listenerObjects[TYPE_ANGULAR_VELOCITY]).angularVelocity(x, y, z);
			}
		};

		callbacks[TYPE_ALL_DATA] = new CallbackListener() {
			public void callback(byte[] data) {
				ByteBuffer bb = ByteBuffer.wrap(data, 4, data.length - 4);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short accX = (bb.getShort());
				short accY = (bb.getShort());
				short accZ = (bb.getShort());
				short magX = (bb.getShort());
				short magY = (bb.getShort());
				short magZ = (bb.getShort());
				short angX = (bb.getShort());
				short angY = (bb.getShort());
				short angZ = (bb.getShort());
				short temperature = (bb.getShort());

				((AllDataListener)listenerObjects[TYPE_ALL_DATA]).allData(accX, accY, accZ, magX, magY, magZ, angX, angY, angZ, temperature);
			}
		};

		callbacks[TYPE_ORIENTATION] = new CallbackListener() {
			public void callback(byte[] data) {
				ByteBuffer bb = ByteBuffer.wrap(data, 4, data.length - 4);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short roll = (bb.getShort());
				short pitch = (bb.getShort());
				short yaw = (bb.getShort());

				((OrientationListener)listenerObjects[TYPE_ORIENTATION]).orientation(roll, pitch, yaw);
			}
		};

		callbacks[TYPE_QUATERNION] = new CallbackListener() {
			public void callback(byte[] data) {
				ByteBuffer bb = ByteBuffer.wrap(data, 4, data.length - 4);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				float x = (bb.getFloat());
				float y = (bb.getFloat());
				float z = (bb.getFloat());
				float w = (bb.getFloat());

				((QuaternionListener)listenerObjects[TYPE_QUATERNION]).quaternion(x, y, z, w);
			}
		};
	}

	public Acceleration getAcceleration() throws IPConnection.TimeoutException {
		ByteBuffer bb = ByteBuffer.allocate(4);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_GET_ACCELERATION);
		bb.putShort((short)4);

		ipcon.write(this, bb, TYPE_GET_ACCELERATION, true);

		byte[] answer = null;
		try {
			answer = answerQueue.poll(IPConnection.TIMEOUT_ANSWER, TimeUnit.MILLISECONDS);
			if(answer == null) {
				throw new IPConnection.TimeoutException("Did not receive answer for getAcceleration in time");
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		bb = ByteBuffer.wrap(answer, 4, answer.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Acceleration obj = new Acceleration();
		obj.x = (bb.getShort());
		obj.y = (bb.getShort());
		obj.z = (bb.getShort());

		semaphoreWrite.release();
		return obj;
	}

	public MagneticField getMagneticField() throws IPConnection.TimeoutException {
		ByteBuffer bb = ByteBuffer.allocate(4);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_GET_MAGNETIC_FIELD);
		bb.putShort((short)4);

		ipcon.write(this, bb, TYPE_GET_MAGNETIC_FIELD, true);

		byte[] answer = null;
		try {
			answer = answerQueue.poll(IPConnection.TIMEOUT_ANSWER, TimeUnit.MILLISECONDS);
			if(answer == null) {
				throw new IPConnection.TimeoutException("Did not receive answer for getMagneticField in time");
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		bb = ByteBuffer.wrap(answer, 4, answer.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		MagneticField obj = new MagneticField();
		obj.x = (bb.getShort());
		obj.y = (bb.getShort());
		obj.z = (bb.getShort());

		semaphoreWrite.release();
		return obj;
	}

	public AngularVelocity getAngularVelocity() throws IPConnection.TimeoutException {
		ByteBuffer bb = ByteBuffer.allocate(4);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_GET_ANGULAR_VELOCITY);
		bb.putShort((short)4);

		ipcon.write(this, bb, TYPE_GET_ANGULAR_VELOCITY, true);

		byte[] answer = null;
		try {
			answer = answerQueue.poll(IPConnection.TIMEOUT_ANSWER, TimeUnit.MILLISECONDS);
			if(answer == null) {
				throw new IPConnection.TimeoutException("Did not receive answer for getAngularVelocity in time");
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		bb = ByteBuffer.wrap(answer, 4, answer.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		AngularVelocity obj = new AngularVelocity();
		obj.x = (bb.getShort());
		obj.y = (bb.getShort());
		obj.z = (bb.getShort());

		semaphoreWrite.release();
		return obj;
	}

	public AllData getAllData() throws IPConnection.TimeoutException {
		ByteBuffer bb = ByteBuffer.allocate(4);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_GET_ALL_DATA);
		bb.putShort((short)4);

		ipcon.write(this, bb, TYPE_GET_ALL_DATA, true);

		byte[] answer = null;
		try {
			answer = answerQueue.poll(IPConnection.TIMEOUT_ANSWER, TimeUnit.MILLISECONDS);
			if(answer == null) {
				throw new IPConnection.TimeoutException("Did not receive answer for getAllData in time");
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		bb = ByteBuffer.wrap(answer, 4, answer.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		AllData obj = new AllData();
		obj.accX = (bb.getShort());
		obj.accY = (bb.getShort());
		obj.accZ = (bb.getShort());
		obj.magX = (bb.getShort());
		obj.magY = (bb.getShort());
		obj.magZ = (bb.getShort());
		obj.angX = (bb.getShort());
		obj.angY = (bb.getShort());
		obj.angZ = (bb.getShort());
		obj.temperature = (bb.getShort());

		semaphoreWrite.release();
		return obj;
	}

	public Orientation getOrientation() throws IPConnection.TimeoutException {
		ByteBuffer bb = ByteBuffer.allocate(4);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_GET_ORIENTATION);
		bb.putShort((short)4);

		ipcon.write(this, bb, TYPE_GET_ORIENTATION, true);

		byte[] answer = null;
		try {
			answer = answerQueue.poll(IPConnection.TIMEOUT_ANSWER, TimeUnit.MILLISECONDS);
			if(answer == null) {
				throw new IPConnection.TimeoutException("Did not receive answer for getOrientation in time");
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		bb = ByteBuffer.wrap(answer, 4, answer.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Orientation obj = new Orientation();
		obj.roll = (bb.getShort());
		obj.pitch = (bb.getShort());
		obj.yaw = (bb.getShort());

		semaphoreWrite.release();
		return obj;
	}

	public Quaternion getQuaternion() throws IPConnection.TimeoutException {
		ByteBuffer bb = ByteBuffer.allocate(4);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_GET_QUATERNION);
		bb.putShort((short)4);

		ipcon.write(this, bb, TYPE_GET_QUATERNION, true);

		byte[] answer = null;
		try {
			answer = answerQueue.poll(IPConnection.TIMEOUT_ANSWER, TimeUnit.MILLISECONDS);
			if(answer == null) {
				throw new IPConnection.TimeoutException("Did not receive answer for getQuaternion in time");
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		bb = ByteBuffer.wrap(answer, 4, answer.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Quaternion obj = new Quaternion();
		obj.x = (bb.getFloat());
		obj.y = (bb.getFloat());
		obj.z = (bb.getFloat());
		obj.w = (bb.getFloat());

		semaphoreWrite.release();
		return obj;
	}

	public short getIMUTemperature() throws IPConnection.TimeoutException {
		ByteBuffer bb = ByteBuffer.allocate(4);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_GET_IMU_TEMPERATURE);
		bb.putShort((short)4);

		ipcon.write(this, bb, TYPE_GET_IMU_TEMPERATURE, true);

		byte[] answer = null;
		try {
			answer = answerQueue.poll(IPConnection.TIMEOUT_ANSWER, TimeUnit.MILLISECONDS);
			if(answer == null) {
				throw new IPConnection.TimeoutException("Did not receive answer for getIMUTemperature in time");
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		bb = ByteBuffer.wrap(answer, 4, answer.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short temperature = (bb.getShort());

		semaphoreWrite.release();
		return temperature;
	}

	public void ledsOn()  {
		ByteBuffer bb = ByteBuffer.allocate(4);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_LEDS_ON);
		bb.putShort((short)4);

		ipcon.write(this, bb, TYPE_LEDS_ON, false);
	}

	public void ledsOff()  {
		ByteBuffer bb = ByteBuffer.allocate(4);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_LEDS_OFF);
		bb.putShort((short)4);

		ipcon.write(this, bb, TYPE_LEDS_OFF, false);
	}

	public boolean areLedsOn() throws IPConnection.TimeoutException {
		ByteBuffer bb = ByteBuffer.allocate(4);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_ARE_LEDS_ON);
		bb.putShort((short)4);

		ipcon.write(this, bb, TYPE_ARE_LEDS_ON, true);

		byte[] answer = null;
		try {
			answer = answerQueue.poll(IPConnection.TIMEOUT_ANSWER, TimeUnit.MILLISECONDS);
			if(answer == null) {
				throw new IPConnection.TimeoutException("Did not receive answer for areLedsOn in time");
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		bb = ByteBuffer.wrap(answer, 4, answer.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean leds = (bb.get()) != 0;

		semaphoreWrite.release();
		return leds;
	}

	public void setAccelerationRange(short range)  {
		ByteBuffer bb = ByteBuffer.allocate(5);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_SET_ACCELERATION_RANGE);
		bb.putShort((short)5);
		bb.put((byte)range);

		ipcon.write(this, bb, TYPE_SET_ACCELERATION_RANGE, false);
	}

	public short getAccelerationRange() throws IPConnection.TimeoutException {
		ByteBuffer bb = ByteBuffer.allocate(4);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_GET_ACCELERATION_RANGE);
		bb.putShort((short)4);

		ipcon.write(this, bb, TYPE_GET_ACCELERATION_RANGE, true);

		byte[] answer = null;
		try {
			answer = answerQueue.poll(IPConnection.TIMEOUT_ANSWER, TimeUnit.MILLISECONDS);
			if(answer == null) {
				throw new IPConnection.TimeoutException("Did not receive answer for getAccelerationRange in time");
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		bb = ByteBuffer.wrap(answer, 4, answer.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short range = IPConnection.unsignedByte(bb.get());

		semaphoreWrite.release();
		return range;
	}

	public void setMagnetometerRange(short range)  {
		ByteBuffer bb = ByteBuffer.allocate(5);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_SET_MAGNETOMETER_RANGE);
		bb.putShort((short)5);
		bb.put((byte)range);

		ipcon.write(this, bb, TYPE_SET_MAGNETOMETER_RANGE, false);
	}

	public short getMagnetometerRange() throws IPConnection.TimeoutException {
		ByteBuffer bb = ByteBuffer.allocate(4);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_GET_MAGNETOMETER_RANGE);
		bb.putShort((short)4);

		ipcon.write(this, bb, TYPE_GET_MAGNETOMETER_RANGE, true);

		byte[] answer = null;
		try {
			answer = answerQueue.poll(IPConnection.TIMEOUT_ANSWER, TimeUnit.MILLISECONDS);
			if(answer == null) {
				throw new IPConnection.TimeoutException("Did not receive answer for getMagnetometerRange in time");
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		bb = ByteBuffer.wrap(answer, 4, answer.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short range = IPConnection.unsignedByte(bb.get());

		semaphoreWrite.release();
		return range;
	}

	public void setConvergenceSpeed(int speed)  {
		ByteBuffer bb = ByteBuffer.allocate(6);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_SET_CONVERGENCE_SPEED);
		bb.putShort((short)6);
		bb.putShort((short)speed);

		ipcon.write(this, bb, TYPE_SET_CONVERGENCE_SPEED, false);
	}

	public int getConvergenceSpeed() throws IPConnection.TimeoutException {
		ByteBuffer bb = ByteBuffer.allocate(4);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_GET_CONVERGENCE_SPEED);
		bb.putShort((short)4);

		ipcon.write(this, bb, TYPE_GET_CONVERGENCE_SPEED, true);

		byte[] answer = null;
		try {
			answer = answerQueue.poll(IPConnection.TIMEOUT_ANSWER, TimeUnit.MILLISECONDS);
			if(answer == null) {
				throw new IPConnection.TimeoutException("Did not receive answer for getConvergenceSpeed in time");
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		bb = ByteBuffer.wrap(answer, 4, answer.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int speed = IPConnection.unsignedShort(bb.getShort());

		semaphoreWrite.release();
		return speed;
	}

	public void setCalibration(short typ, short[] data)  {
		ByteBuffer bb = ByteBuffer.allocate(25);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_SET_CALIBRATION);
		bb.putShort((short)25);
		bb.put((byte)typ);
		for(int i = 0; i < 10; i++) {
			bb.putShort((short)data[i]);
		}


		ipcon.write(this, bb, TYPE_SET_CALIBRATION, false);
	}

	public short[] getCalibration(short typ) throws IPConnection.TimeoutException {
		ByteBuffer bb = ByteBuffer.allocate(5);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_GET_CALIBRATION);
		bb.putShort((short)5);
		bb.put((byte)typ);

		ipcon.write(this, bb, TYPE_GET_CALIBRATION, true);

		byte[] answer = null;
		try {
			answer = answerQueue.poll(IPConnection.TIMEOUT_ANSWER, TimeUnit.MILLISECONDS);
			if(answer == null) {
				throw new IPConnection.TimeoutException("Did not receive answer for getCalibration in time");
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		bb = ByteBuffer.wrap(answer, 4, answer.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short[] data = new short[10];
		for(int i = 0; i < 10; i++) {
			data[i] = (bb.getShort());
		}


		semaphoreWrite.release();
		return data;
	}

	public void setAccelerationPeriod(long period)  {
		ByteBuffer bb = ByteBuffer.allocate(8);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_SET_ACCELERATION_PERIOD);
		bb.putShort((short)8);
		bb.putInt((int)period);

		ipcon.write(this, bb, TYPE_SET_ACCELERATION_PERIOD, false);
	}

	public long getAccelerationPeriod() throws IPConnection.TimeoutException {
		ByteBuffer bb = ByteBuffer.allocate(4);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_GET_ACCELERATION_PERIOD);
		bb.putShort((short)4);

		ipcon.write(this, bb, TYPE_GET_ACCELERATION_PERIOD, true);

		byte[] answer = null;
		try {
			answer = answerQueue.poll(IPConnection.TIMEOUT_ANSWER, TimeUnit.MILLISECONDS);
			if(answer == null) {
				throw new IPConnection.TimeoutException("Did not receive answer for getAccelerationPeriod in time");
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		bb = ByteBuffer.wrap(answer, 4, answer.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		semaphoreWrite.release();
		return period;
	}

	public void setMagneticFieldPeriod(long period)  {
		ByteBuffer bb = ByteBuffer.allocate(8);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_SET_MAGNETIC_FIELD_PERIOD);
		bb.putShort((short)8);
		bb.putInt((int)period);

		ipcon.write(this, bb, TYPE_SET_MAGNETIC_FIELD_PERIOD, false);
	}

	public long getMagneticFieldPeriod() throws IPConnection.TimeoutException {
		ByteBuffer bb = ByteBuffer.allocate(4);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_GET_MAGNETIC_FIELD_PERIOD);
		bb.putShort((short)4);

		ipcon.write(this, bb, TYPE_GET_MAGNETIC_FIELD_PERIOD, true);

		byte[] answer = null;
		try {
			answer = answerQueue.poll(IPConnection.TIMEOUT_ANSWER, TimeUnit.MILLISECONDS);
			if(answer == null) {
				throw new IPConnection.TimeoutException("Did not receive answer for getMagneticFieldPeriod in time");
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		bb = ByteBuffer.wrap(answer, 4, answer.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		semaphoreWrite.release();
		return period;
	}

	public void setAngularVelocityPeriod(long period)  {
		ByteBuffer bb = ByteBuffer.allocate(8);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_SET_ANGULAR_VELOCITY_PERIOD);
		bb.putShort((short)8);
		bb.putInt((int)period);

		ipcon.write(this, bb, TYPE_SET_ANGULAR_VELOCITY_PERIOD, false);
	}

	public long getAngularVelocityPeriod() throws IPConnection.TimeoutException {
		ByteBuffer bb = ByteBuffer.allocate(4);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_GET_ANGULAR_VELOCITY_PERIOD);
		bb.putShort((short)4);

		ipcon.write(this, bb, TYPE_GET_ANGULAR_VELOCITY_PERIOD, true);

		byte[] answer = null;
		try {
			answer = answerQueue.poll(IPConnection.TIMEOUT_ANSWER, TimeUnit.MILLISECONDS);
			if(answer == null) {
				throw new IPConnection.TimeoutException("Did not receive answer for getAngularVelocityPeriod in time");
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		bb = ByteBuffer.wrap(answer, 4, answer.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		semaphoreWrite.release();
		return period;
	}

	public void setAllDataPeriod(long period)  {
		ByteBuffer bb = ByteBuffer.allocate(8);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_SET_ALL_DATA_PERIOD);
		bb.putShort((short)8);
		bb.putInt((int)period);

		ipcon.write(this, bb, TYPE_SET_ALL_DATA_PERIOD, false);
	}

	public long getAllDataPeriod() throws IPConnection.TimeoutException {
		ByteBuffer bb = ByteBuffer.allocate(4);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_GET_ALL_DATA_PERIOD);
		bb.putShort((short)4);

		ipcon.write(this, bb, TYPE_GET_ALL_DATA_PERIOD, true);

		byte[] answer = null;
		try {
			answer = answerQueue.poll(IPConnection.TIMEOUT_ANSWER, TimeUnit.MILLISECONDS);
			if(answer == null) {
				throw new IPConnection.TimeoutException("Did not receive answer for getAllDataPeriod in time");
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		bb = ByteBuffer.wrap(answer, 4, answer.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		semaphoreWrite.release();
		return period;
	}

	public void setOrientationPeriod(long period)  {
		ByteBuffer bb = ByteBuffer.allocate(8);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_SET_ORIENTATION_PERIOD);
		bb.putShort((short)8);
		bb.putInt((int)period);

		ipcon.write(this, bb, TYPE_SET_ORIENTATION_PERIOD, false);
	}

	public long getOrientationPeriod() throws IPConnection.TimeoutException {
		ByteBuffer bb = ByteBuffer.allocate(4);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_GET_ORIENTATION_PERIOD);
		bb.putShort((short)4);

		ipcon.write(this, bb, TYPE_GET_ORIENTATION_PERIOD, true);

		byte[] answer = null;
		try {
			answer = answerQueue.poll(IPConnection.TIMEOUT_ANSWER, TimeUnit.MILLISECONDS);
			if(answer == null) {
				throw new IPConnection.TimeoutException("Did not receive answer for getOrientationPeriod in time");
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		bb = ByteBuffer.wrap(answer, 4, answer.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		semaphoreWrite.release();
		return period;
	}

	public void setQuaternionPeriod(long period)  {
		ByteBuffer bb = ByteBuffer.allocate(8);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_SET_QUATERNION_PERIOD);
		bb.putShort((short)8);
		bb.putInt((int)period);

		ipcon.write(this, bb, TYPE_SET_QUATERNION_PERIOD, false);
	}

	public long getQuaternionPeriod() throws IPConnection.TimeoutException {
		ByteBuffer bb = ByteBuffer.allocate(4);
		bb.order(ByteOrder.LITTLE_ENDIAN);
		bb.put((byte)stackID);
		bb.put((byte)TYPE_GET_QUATERNION_PERIOD);
		bb.putShort((short)4);

		ipcon.write(this, bb, TYPE_GET_QUATERNION_PERIOD, true);

		byte[] answer = null;
		try {
			answer = answerQueue.poll(IPConnection.TIMEOUT_ANSWER, TimeUnit.MILLISECONDS);
			if(answer == null) {
				throw new IPConnection.TimeoutException("Did not receive answer for getQuaternionPeriod in time");
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		bb = ByteBuffer.wrap(answer, 4, answer.length - 4);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		semaphoreWrite.release();
		return period;
	}

	public Version getVersion() {
		Version version = new Version();
		version.name = name;
		version.firmwareVersion[0] = firmwareVersion[0];
		version.firmwareVersion[1] = firmwareVersion[1];
		version.firmwareVersion[2] = firmwareVersion[2];
		version.bindingVersion[0] = bindingVersion[0];
		version.bindingVersion[1] = bindingVersion[1];
		version.bindingVersion[2] = bindingVersion[2];

		return version;
	}

	public void addListener(Object o) {
		if(o instanceof AccelerationListener) {
			listenerObjects[TYPE_ACCELERATION] = o;
		} else if(o instanceof MagneticFieldListener) {
			listenerObjects[TYPE_MAGNETIC_FIELD] = o;
		} else if(o instanceof AngularVelocityListener) {
			listenerObjects[TYPE_ANGULAR_VELOCITY] = o;
		} else if(o instanceof AllDataListener) {
			listenerObjects[TYPE_ALL_DATA] = o;
		} else if(o instanceof OrientationListener) {
			listenerObjects[TYPE_ORIENTATION] = o;
		} else if(o instanceof QuaternionListener) {
			listenerObjects[TYPE_QUATERNION] = o;
		}
	}
}